#if !defined(AFX_PRESSCONTROL_H__007E8A4C_09D0_47E1_AFE6_AF5D3C508CB2__INCLUDED_)
#define AFX_PRESSCONTROL_H__007E8A4C_09D0_47E1_AFE6_AF5D3C508CB2__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PressControl.h : header file
//
#include "ComPortUI.h"
#include "gtComPort.h"
/////////////////////////////////////////////////////////////////////////////
// CPressControl window
#define MAX_PRESSURE 30
#define DEFAULT_DEVICE_ID_PRESS "A"

#define DEFAULT_PRESS_COMPORT 5
// CUVControl window
static void CALLBACK MMPressTimerProcess( UINT uID,			//uTimerID
									UINT uMsg,			//dwUser : UserParam
									DWORD dwUser,		//Reserved
									DWORD dw1,			//Reserved
									DWORD dw2);			//Reserved 
#define DEFAULT_MMTIMER_RESOLUTION_PRESS 5

#define TIMER_EVENT_QUERY_PRESS_STATUS		1

class CPressControl : public CWnd
{
// Construction
public:
	void Init(CWnd *pWnd);
	CWnd *m_pParentWnd;
	void CommSend(CString str);
	double m_fMaxPressure;
	double m_fDesiredPressure;
	CString m_strPrintRecv;
	void ParseData(CString strRecv);
	CString m_strCommRecv;
	void ReceiveData(void);
	BOOL m_bComPortOpen;
//	CComPortUI m_ComPortUI;
	CgtComPort *m_pComPort;

	CPressControl();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPressControl)
	//}}AFX_VIRTUAL

// Implementation
public:
	void SetComPortInfo(CComPortUI *pComPortUI);
	void Init(CWnd *pWnd, CgtComPort *pComPort);
	void Set(void);
	void PressControl(CString strDesiredPressure);
	UINT m_nTimerID;
	int m_iTimerEvent;
	void SetMMTimer(int iEvent, int iTime);
	CString m_strDeviceID;
	void PressControl(BOOL bUpDown);
	void Status(void);
	virtual ~CPressControl();

	// Generated message map functions
protected:
	//{{AFX_MSG(CPressControl)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PRESSCONTROL_H__007E8A4C_09D0_47E1_AFE6_AF5D3C508CB2__INCLUDED_)
