// ValveSet.cpp : implementation file
//

#include "stdafx.h"
#include "BIOD_Lite.h"
#include "ValveSet.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CValveSet dialog


CValveSet::CValveSet(CWnd* pParent /*=NULL*/)
	: CDialog(CValveSet::IDD, pParent)
{
	//{{AFX_DATA_INIT(CValveSet)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CValveSet::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CValveSet)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CValveSet, CDialog)
	//{{AFX_MSG_MAP(CValveSet)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_PORT0, OnButtonPort0)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_PORT1, OnButtonPort1)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_PORT2, OnButtonPort2)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_PORT3, OnButtonPort3)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE00, OnButtonValve00)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE01, OnButtonValve01)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE02, OnButtonValve02)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE03, OnButtonValve03)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE04, OnButtonValve04)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE05, OnButtonValve05)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE06, OnButtonValve06)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE07, OnButtonValve07)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE10, OnButtonValve10)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE11, OnButtonValve11)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE12, OnButtonValve12)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE13, OnButtonValve13)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE14, OnButtonValve14)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE15, OnButtonValve15)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE16, OnButtonValve16)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE17, OnButtonValve17)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE20, OnButtonValve20)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE21, OnButtonValve21)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE22, OnButtonValve22)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE23, OnButtonValve23)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE24, OnButtonValve24)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE25, OnButtonValve25)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE26, OnButtonValve26)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE27, OnButtonValve27)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE30, OnButtonValve30)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE31, OnButtonValve31)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE32, OnButtonValve32)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE33, OnButtonValve33)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE34, OnButtonValve34)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE35, OnButtonValve35)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE36, OnButtonValve36)
	ON_BN_CLICKED(IDC_BUTTON_VALVESET_VALVE37, OnButtonValve37)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CValveSet message handlers

BOOL CValveSet::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CButton *pButton;
	for(int i=0;i<NUM_OF_PORT;i++)
	{
		for(int j=0;j<NUM_OF_LINE;j++)
		{
			pButton = (CButton *)GetDlgItem( IDC_BUTTON_VALVESET_VALVE00+(i*NUM_OF_LINE)+j );
			pButton->SetWindowText("X");			
			m_iValveStatus[i][j] = VALVE_STAT_DISEL;
		}
		pButton = (CButton *)GetDlgItem(IDC_BUTTON_VALVESET_PORT0+i);
		pButton->SetWindowText("ALL DISEL");
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CValveSet::PortAllOnOff(int iPort)
{
	CString strStatus;
	int iLine;
	int iStatus;
	CButton *pButton;
	pButton = (CButton *)GetDlgItem( IDC_BUTTON_VALVESET_PORT0+iPort );
	pButton->GetWindowText(strStatus);

	if( strStatus == "ALL DISEL" )
	{
		pButton->SetWindowText("ALL ON");		
		iStatus = VALVE_STAT_ON;
		strStatus = "O";
	}
	else if( strStatus == "ALL ON" )
	{
		pButton->SetWindowText("ALL OFF");		
		iStatus = VALVE_STAT_OFF;
		strStatus = "F";
	}	
	else if( strStatus == "ALL OFF" )
	{
		pButton->SetWindowText("ALL DISEL");
		iStatus = VALVE_STAT_DISEL;
		strStatus = "X";
	}
	
	for(iLine=0;iLine<NUM_OF_LINE;iLine++)
	{
		GetDlgItem( IDC_BUTTON_VALVESET_VALVE00+(iPort*NUM_OF_LINE)+iLine )->SetWindowText(strStatus);
		m_iValveStatus[iPort][iLine] = iStatus;
	}
}


void CValveSet::LineOnOff(int iPort, int iLine)
{
	CString strStatus;
	int iStatus;
	CButton *pButton;

	pButton = (CButton *)GetDlgItem( IDC_BUTTON_VALVESET_VALVE00+(iPort*NUM_OF_LINE)+iLine );
	iStatus = m_iValveStatus[iPort][iLine];

	if( iStatus == VALVE_STAT_DISEL )
	{
	//	pButton->SetCheck(VALVE_ON);
		iStatus = VALVE_STAT_ON;
		strStatus = "O";
	}
	else if( iStatus == VALVE_STAT_ON )
	{
	//	pButton->SetCheck(VALVE_OFF);
		iStatus = VALVE_STAT_OFF;
		strStatus = "F";
	}
	else if( iStatus == VALVE_STAT_OFF )
	{
		iStatus = VALVE_STAT_DISEL;
		strStatus = "X";
	}

	m_iValveStatus[iPort][iLine] = iStatus;
	pButton->SetWindowText(strStatus);
}


void CValveSet::OnButtonPort0() 
{
	// TODO: Add your control notification handler code here
	PortAllOnOff(0);
}

void CValveSet::OnButtonPort1() 
{
	// TODO: Add your control notification handler code here
	PortAllOnOff(1);
}

void CValveSet::OnButtonPort2() 
{
	// TODO: Add your control notification handler code here
	PortAllOnOff(2);
}

void CValveSet::OnButtonPort3() 
{
	// TODO: Add your control notification handler code here
	PortAllOnOff(3);
}

void CValveSet::OnButtonValve00() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(0, 0);
}

void CValveSet::OnButtonValve01() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(0, 1);
}

void CValveSet::OnButtonValve02() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(0, 2);
}

void CValveSet::OnButtonValve03() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(0, 3);
}

void CValveSet::OnButtonValve04() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(0, 4);
}

void CValveSet::OnButtonValve05() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(0, 5);
}

void CValveSet::OnButtonValve06() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(0, 6);
}

void CValveSet::OnButtonValve07() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(0, 7);
}

void CValveSet::OnButtonValve10() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(1, 0);
}

void CValveSet::OnButtonValve11() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(1, 1);
}

void CValveSet::OnButtonValve12() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(1, 2);
}

void CValveSet::OnButtonValve13() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(1, 3);
}

void CValveSet::OnButtonValve14() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(1, 4);
}

void CValveSet::OnButtonValve15() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(1, 5);
}

void CValveSet::OnButtonValve16() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(1, 6);
}

void CValveSet::OnButtonValve17() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(1, 7);
}

void CValveSet::OnButtonValve20() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(2, 0);
}

void CValveSet::OnButtonValve21() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(2, 1);
}

void CValveSet::OnButtonValve22() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(2, 2);
}

void CValveSet::OnButtonValve23() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(2, 3);
}

void CValveSet::OnButtonValve24() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(2, 4);
}

void CValveSet::OnButtonValve25() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(2, 5);
}

void CValveSet::OnButtonValve26() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(2, 6);
}

void CValveSet::OnButtonValve27() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(2, 7);
}

void CValveSet::OnButtonValve30() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(3, 0);
}

void CValveSet::OnButtonValve31() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(3, 1);
}

void CValveSet::OnButtonValve32() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(3, 2);
}

void CValveSet::OnButtonValve33() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(3, 3);
}

void CValveSet::OnButtonValve34() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(3, 4);
}

void CValveSet::OnButtonValve35() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(3, 5);
}

void CValveSet::OnButtonValve36() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(3, 6);
}

void CValveSet::OnButtonValve37() 
{
	// TODO: Add your control notification handler code here
	LineOnOff(3, 7);
}



